Error when clicking button 'TEST' with for the rule "ELSE" in rule based renderer

2017-07-04 10:43 AM - Julien Monticolo

Status: Closed

Priority: Normal

Assignee:

Category: Symbology

Affected QGIS version:2.18.10 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 24686

Description

Hi,

For rule based styling or rule base labeling, when the filter is ELSE and the button 'Test' is clicked, an error appear :

:syntax error, unexpected ELSE

BTW the rule works perfectly.

Another thing, the ELSE expression can't be found in the expression builder.

History

#1 - 2017-07-05 04:33 PM - Giovanni Manghi

- Status changed from Open to Feedback

Just tried an expression that contains "ELSE" (the function is "CASE", this is why you don't "find" it with the filter) and it works perfectly (the "test" button).

Can you post the expression ypu are using? thanks.

#2 - 2017-07-05 04:43 PM - Julien Monticolo

To reproduce :

    1. First rule :

    -  rule name : 'Rule 1'

    -  filter : $id <= 10

    1. Second rule :

    -  rule name : 'Rule 2'

    -  filter : ELSE

And if I click the 'test' button on the second rule, the error appear.

Note that if I create a categorized style and I switch after to the rule based styling, the rule 'ELSE' is automaticly added, and if I test this rule, the same error

appear too.
#3 - 2017-07-06 02:52 PM - Giovanni Manghi

- Category changed from Expressions to Symbology

- Status changed from Feedback to Open

- Subject changed from Error when clicking button 'TEST' with the rule ELSE to Error when clicking button 'TEST' with for the rule "ELSE" in rule based 

renderer

Right, I forgot of that scenario.

#4 - 2018-10-10 05:06 PM - Harrissou Santanna

Still valid in master 3.3, even with the dedicated "Else" radiobutton: if you enable the Else option, you have no access to the Test button but if you then

check the Filter button, the line edit widget is filled with an "ELSE" expression that returns the Filter expression parsing error: syntax error, unexpected

ELSE message when you press "Test".

#5 - 2019-03-09 03:10 PM - Giovanni Manghi

- Status changed from Open to Closed

- Resolution set to end of life

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

QGIS 3.4 has recently become our new Long Term Release  (LTR) version. This is a major step in our history – a long term release version based on the

massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR  as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version

will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the

relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the

ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help

you plan your deployment of QGIS into an operational environment.

The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and

administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.
